unit CRLF_Main;

{**********************************************************************

 convert UNIX file (lines terminated by $0A) to Windows format
 (lines terminated by $0D$0A)

 (c) 1999 by Christian Maas
             www.chmaas.handshake.de
             chmaas@hit.sb.sub.de

 **********************************************************************}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Gauges;

type
  TForm1 = class(TForm)
    ButtonConvert: TButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Gauge1: TGauge;
    ButtonAbort: TButton;
    procedure ButtonConvertClick(Sender: TObject);
    procedure ButtonAbortClick(Sender: TObject);
  private
    { Private declarations }
    Aborted: boolean;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

{**********************************************************************
 Split string s at position of BreakStr: return value is the part
 before BreakStr. In addition, remove from s part until BreakStr
 **********************************************************************}
function Split (var s: string; BreakStr: string): string;
var i: integer;
begin
  i := pos (BreakStr, s);
  { part before BreakStr }
  Result := copy (s, 1,  i - 1);
  { remove part until BreakStr }
  s := copy (s, i + length (BreakStr), length (s) - length (BreakStr) +1);
end;

{**********************************************************************
 convert UNIX file (lines terminated by $0A) to Windows format
 (lines terminated by $0D$0A)
 **********************************************************************}

procedure TForm1.ButtonConvertClick(Sender: TObject);
var fUnix, fWin: TextFile;
    f: file of byte;
    s, t: string;

begin

  if not OpenDialog1.Execute then
    Exit;

  if not SaveDialog1.Execute then
    Exit;

  ButtonAbort.Enabled := true;
  Aborted := false;

  { file size for gauge }
  AssignFile(f, OpenDialog1.FileName);
  Reset (f);
  Gauge1.Progress := 0;
  Gauge1.MaxValue := FileSize (f);
  CloseFile (f);

  AssignFile (fUnix, OpenDialog1.FileName);
  Reset (fUnix);

  AssignFile (fWin, SaveDialog1.FileName);
  Rewrite (fWin);

  while not eof (fUnix) do begin
    readln (fUnix, s);
    while pos (#10, s) > 0 do begin
      t := Split (s, #10);
      writeln (fWin, t);
      Gauge1.Progress := Gauge1.Progress + length (t) + 1;
      Application.ProcessMessages;
      if Aborted then
        break;
    end;
    Application.ProcessMessages;
    if Aborted then
      break;
    writeln (fWin, s);
    Gauge1.Progress := Gauge1.Progress + length (s) + 2;
  end;

  CloseFile (fUnix);
  CloseFile (fWin);

  ButtonAbort.Enabled := false;

end;

{**********************************************************************
 abort converting of file
 **********************************************************************}

procedure TForm1.ButtonAbortClick(Sender: TObject);
begin
  Aborted := true;
  Gauge1.Progress := 0;
end;

end.
